//	Rear bicycle light finite state machine
//
//	This module determines how the light functions in the given state and what
// the next state is for the given state.  

/* For this lab, you need to implement the finite state machine following the
   specifications in the lab hand-out */

module bicycle_fsm(clk, reset, button, light, fast_speed, slow_speed);
input clk;
input reset;
input button;
output light;
output [7:0] fast_speed, slow_speed;


// your fsm here //



// Recall, for the flashing light states:
// Each press of the button should either double or half the current speed, depending.
//
// if the state is "flashing fast", then the speed should decrease with "up" and increase 
// with "down".  It should never go slower than the initial flashing speed (1 second on, 1 second off). 
// if the state is "flashing slow", then the speed should increase with "up" and decrease
// with "down".  It should never go faster than the initial flashing speed (1 second on, 1 second off).
//
// the output speed value should be the net number of times up has been pressed (ie four ups and 
// two down presses in the slow mode would result in an output of 2)
//
// there are eight bits to represent each of the speeds: fast or slow.


endmodule