//	Hexadecimal display
//
//	This module takes in a four-bit hexadecimal number and outputs the corresponding bits in a
//	7-segment display.  
//
//	Last revision: Feb 03, 2007
// Revised by: jriley1@stanford.edu

module hexadecimal_display(s, sevenseg);
input [3:0] s;               // input four-bit number
output reg [6:0] sevenseg;   // output seven-segment display corresponding to hexadecimal number

// segment display correspdonding to hexadecimal numbers
always @(*)
case (s)
	4'h0: sevenseg = 7'b1111110;
	4'h1: sevenseg = 7'b0110000;
	4'h2: sevenseg = 7'b1101101;
	4'h3: sevenseg = 7'b1111001;
	4'h4: sevenseg = 7'b0110011;
	4'h5: sevenseg = 7'b1011011;
	4'h6: sevenseg = 7'b1011111;
	4'h7: sevenseg = 7'b1110000;
	4'h8: sevenseg = 7'b1111111;
	4'h9: sevenseg = 7'b1111011;
	4'hA: sevenseg = 7'b1110111;
	4'hB: sevenseg = 7'b0011111;
	4'hC: sevenseg = 7'b1001110;
	4'hD: sevenseg = 7'b0111101;
	4'hE: sevenseg = 7'b1001111;
	4'hF: sevenseg = 7'b1000111;
	default: begin
		sevenseg = 7'b0000000;
	end
endcase

endmodule	
